"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _helperPluginUtils() {
  const data = require("@babel/helper-plugin-utils");

  _helperPluginUtils = function () {
    return data;
  };

  return data;
}

function _pluginSyntaxEnum() {
  const data = _interopRequireDefault(require("@babel/plugin-syntax-enum"));

  _pluginSyntaxEnum = function () {
    return data;
  };

  return data;
}

function _core() {
  const data = require("@babel/core");

  _core = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _helperPluginUtils().declare)(api => {
  api.assertVersion(7);
  return {
    inherits: _pluginSyntaxEnum().default,
    visitor: {
      EnumDeclaration(path) {
        const {
          node
        } = path;
        path.replaceWith(makePolyfillCall(node.id, node.members));
      }

    }
  };
});

exports.default = _default;

function makePolyfillCall(id, members) {
  const properties = members.map(member => {
    if (member.initializer) {
      if (member.initializer.type === "EnumDeclaration") {
        return _core().types.objectProperty(_core().types.identifier(member.id.name), makePolyfillCall(member.initializer.id, member.initializer.members));
      }

      return _core().types.objectProperty(_core().types.identifier(member.id.name), _core().types.cloneNode(member.initializer));
    }

    return _core().types.objectProperty(_core().types.identifier(member.id.name), _core().types.callExpression(_core().types.identifier("Symbol"), [_core().types.stringLiteral(member.id.name)]));
  });

  const polyfillCall = _core().types.callExpression(_core().types.identifier("PolyfilledEnum"), [_core().types.objectExpression(properties)]);

  if (!id) {
    return polyfillCall;
  }

  return _core().types.variableDeclaration("const", [_core().types.variableDeclarator(_core().types.identifier(id.name), polyfillCall)]);
}